# TODO: mruby, neverbleed?
#
# Conditional build:
%bcond_without	asio		# libnghttp2_asio C++ library
%bcond_without	static_libs	# static libraries
%bcond_without	tests		# "make check" call

Summary:	HTTP/2.0 C library
Summary(pl.UTF-8):	Biblioteka C HTTP/2.0
Name:		nghttp2
Version:	1.46.0
Release:	1
License:	MIT
Group:		Libraries
#Source0Download: https://github.com/nghttp2/nghttp2/releases
Source0:	https://github.com/nghttp2/nghttp2/releases/download/v%{version}/%{name}-%{version}.tar.xz
# Source0-md5:	10e7f75525c4f6680a73c55433723fd6
Patch0:		%{name}-link.patch
Patch1:		%{name}-python.patch
URL:		https://nghttp2.org/
%{?with_tests:BuildRequires:	CUnit >= 2.1}
BuildRequires:	autoconf >= 2.61
BuildRequires:	automake
%{?with_asio:BuildRequires:	boost-devel >= 1.54.0}
BuildRequires:	c-ares-devel >= 1.7.5
BuildRequires:	jansson-devel >= 2.5
BuildRequires:	libev-devel
# for examples
BuildRequires:	libevent-devel >= 2.0.8
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	libtool >= 2:2.2.6
BuildRequires:	libxml2-devel >= 1:2.6.26
BuildRequires:	openssl-devel >= 1.0.1
BuildRequires:	pkgconfig >= 1:0.20
BuildRequires:	python3 >= 1:3.8
BuildRequires:	python3-Cython >= 0.19
BuildRequires:	python3-devel >= 1:3.8
BuildRequires:	python3-setuptools
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.734
BuildRequires:	sed >= 4.0
BuildRequires:	systemd-devel >= 1:209
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRequires:	zlib-devel >= 1.2.3
Requires:	%{name}-libs = %{version}-%{release}
Requires:	c-ares >= 1.7.5
Requires:	jansson >= 2.5
# noinst examples only
#Requires:	libevent >= 2.0.8
Requires:	libxml2 >= 1:2.6.26
Requires:	openssl >= 1.0.1
Requires:	zlib >= 1.2.3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is an experimental implementation of Hypertext Transfer Protocol
version 2.0.

%description -l pl.UTF-8
Ta biblioteka jest eksperymentalną implementacją protokołu HTTP
(Hypertext Transfer Protocol) w wersji 2.0.

%package libs
Summary:	A library implementing the HTTP/2 protocol
Summary(pl.UTF-8):	Biblioteka implementująca protokół HTTP/2
Group:		Libraries
Conflicts:	nghttp2 < 1.11.1-2

%description libs
libnghttp2 is a library implementing the Hypertext Transfer Protocol
version 2 (HTTP/2) protocol in C.

%description libs -l pl.UTF-8
libnghttp2 to napisana w C biblioteka implementująca protokół HTTP/2
(Hypertext Transfer Protocol w wersji 2).

%package devel
Summary:	Files needed for developing with libnghttp2
Summary(pl.UTF-8):	Pliki niezbędne do tworzenia aplikacji z użyciem libnghttp2
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Files needed for building applications with libnghttp2.

%description devel -l pl.UTF-8
Pliki niezbędne do tworzenia aplikacji z użyciem libnghttp2.

%package static
Summary:	Static libnghttp2 library
Summary(pl.UTF-8):	Statyczna biblioteka libnghttp2
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libnghttp2 library.

%description static -l pl.UTF-8
Statyczna biblioteka libnghttp2.

%package -n python3-nghttp2
Summary:	Python binding to nghttp2 library
Summary(pl.UTF-8):	Wiązanie Pythona do biblioteki nghttp2
Group:		Libraries/Python
Requires:	%{name} = %{version}-%{release}
Requires:	python3-libs >= 1:3.8
Obsoletes:	python-nghttp2 < 1.43.0

%description -n python3-nghttp2
Python binding to nghttp2 library.

%description -n python3-nghttp2 -l pl.UTF-8
Wiązanie Pythona do biblioteki nghttp2.

%package asio
Summary:	HTTP/2.0 C++ library
Summary(pl.UTF-8):	Biblioteka C++ HTTP/2.0
Group:		Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	openssl >= 1.0.1

%description asio
HTTP/2.0 C++ library.

%description asio -l pl.UTF-8
Biblioteka C++ HTTP/2.0.

%package asio-devel
Summary:	Header file for nghttp2_asio library
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki nghttp2_asio
Group:		Development/Libraries
Requires:	%{name}-asio = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	libstdc++-devel >= 6:4.7

%description asio-devel
Header file for nghttp2_asio library.

%description asio-devel -l pl.UTF-8
Plik nagłówkowy biblioteki nghttp2_asio.

%package asio-static
Summary:	Static libnghttp2_asio library
Summary(pl.UTF-8):	Statyczna biblioteka libnghttp2_asio
Group:		Development/Libraries
Requires:	%{name}-asio-devel = %{version}-%{release}

%description asio-static
Static libnghttp2_asio library.

%description asio-static -l pl.UTF-8
Statyczna biblioteka libnghttp2_asio.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%{__sed} -i -e '1s,/usr/bin/env python,%{__python3},' script/fetch-ocsp-response

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--enable-app \
	%{?with_asio:--enable-asio-lib} \
	--enable-hpack-tools \
	--enable-python-bindings \
	--disable-silent-rules \
	%{!?with_static_libs:--disable-static} \
	--with-cython=/usr/bin/cython3 \
	--without-jemalloc

%{__make}

%if %{with tests}
%{__make} check
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libnghttp2*.la
# packaged as %doc
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/nghttp2

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	asio -p /sbin/ldconfig
%postun	asio -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS COPYING ChangeLog README.rst
%attr(755,root,root) %{_bindir}/deflatehd
%attr(755,root,root) %{_bindir}/h2load
%attr(755,root,root) %{_bindir}/inflatehd
%attr(755,root,root) %{_bindir}/nghttp
%attr(755,root,root) %{_bindir}/nghttpd
%attr(755,root,root) %{_bindir}/nghttpx
%dir %{_datadir}/nghttp2
%attr(755,root,root) %{_datadir}/nghttp2/fetch-ocsp-response
%{_mandir}/man1/h2load.1*
%{_mandir}/man1/nghttp.1*
%{_mandir}/man1/nghttpd.1*
%{_mandir}/man1/nghttpx.1*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libnghttp2.so.14

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2.so
%dir %{_includedir}/nghttp2
%{_includedir}/nghttp2/nghttp2*.h
%{_pkgconfigdir}/libnghttp2.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libnghttp2.a
%endif

%files -n python3-nghttp2
%defattr(644,root,root,755)
%attr(755,root,root) %{py3_sitedir}/nghttp2.cpython-*.so
%{py3_sitedir}/python_nghttp2-%{version}-py*.egg-info

%if %{with asio}
%files asio
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2_asio.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libnghttp2_asio.so.1

%files asio-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2_asio.so
%{_includedir}/nghttp2/asio_http2.h
%{_includedir}/nghttp2/asio_http2_client.h
%{_includedir}/nghttp2/asio_http2_server.h
%{_pkgconfigdir}/libnghttp2_asio.pc

%if %{with static_libs}
%files asio-static
%defattr(644,root,root,755)
%{_libdir}/libnghttp2_asio.a
%endif
%endif
%changelog
* Sun Oct 24 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nghttp2.git;a=log;h=master

* Sun Oct 24 2021 Jan Palus <atler@pld-linux.org> b20f53e
- up to 1.46.0

* Fri Sep 24 2021 Jan Rękorajski <baggins@pld-linux.org> d003852
- rebuild with openssl 3.0.0

* Tue Sep 21 2021 Jan Palus <atler@pld-linux.org> 83f17b8
- up to 1.45.1

* Mon Sep 20 2021 Jan Palus <atler@pld-linux.org> 8d90b84
- up to 1.45.0

* Sun Jul 18 2021 Jan Palus <atler@pld-linux.org> 73c1028
- up to 1.44.0

* Sun Jul 18 2021 Jan Palus <atler@pld-linux.org> 76a36a9
- explicitly pass cython path

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> f504afb
- release 3 (by relup.sh)

* Thu Feb 11 2021 Jan Palus <atler@pld-linux.org> 2a3e23c
- unbreak shebang; rel 2

* Wed Feb 10 2021 Jan Palus <atler@pld-linux.org> f04ce4b
- up to 1.43.0

* Tue Nov 24 2020 Jan Palus <atler@pld-linux.org> bc49680
- up to 1.42.0

* Wed Jul 01 2020 Jan Palus <atler@pld-linux.org> 051e21b
- up to 1.41.0

* Sat Jan 25 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 583db44
- up to 1.40.0

* Fri Sep 13 2019 Jakub Bogusz <qboosh@pld-linux.org> 77c72d7
- updated to 1.39.2

* Fri Jul 19 2019 Jakub Bogusz <qboosh@pld-linux.org> b17c3c9
- updated to 1.39.1
- removed obsolete boost-1.70 patch

* Thu Apr 18 2019 Adam Gołębiowski <adamg@pld-linux.org> 208e837
- updated to 1.38.0

* Thu Apr 18 2019 Adam Gołębiowski <adamg@pld-linux.org> 108cddf
- release 2, rebuild against boost 1.70

* Mon Mar 11 2019 Adam Gołębiowski <adamg@pld-linux.org> 8496610
- updated to 1.37.0

* Mon Feb 18 2019 Adam Gołębiowski <adamg@pld-linux.org> 0f2292c
- updated to 1.36.0

* Mon Dec 10 2018 Adam Gołębiowski <adamg@pld-linux.org> 7f8a4a9
- updated to 1.35.1

* Fri Nov 23 2018 Adam Gołębiowski <adamg@pld-linux.org> 336f62b
- updated to 1.35.0

